Index: src/defs.hpp
===================================================================
--- src/defs.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/defs.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -8,21 +8,22 @@
 #define DEFS_HPP_
 
-#define MYEPSILON 1e-13   //!< machine epsilon precision
-#define NDIM  3   //!< number of spatial dimensions
-#define MAX_ELEMENTS 128  //!< maximum number of elements for certain lookup tables 
-#define AtomicLengthToAngstroem  0.52917721 //!< conversion factor from atomic length/bohrradius to angstroem
-#define AtomicEnergyToKelvin 315774.67  //!< conversion factor from atomic energy to kelvin via boltzmann factor
-#define KelvinToAtomicTemperature 3.1668152e-06    //!< conversion factor for Kelvin to atomic temperature (Hartree over k_B)
-#define KelvinToeV 8.6173422e-05                   //!< conversion factor for Kelvin to Ht (k_B * T = energy), thus Boltzmann constant in eV/K
-#define AtomicMassUnitsToeV 931494088.        //!< conversion factor for atomic weight in units to mass in eV
-#define AtomicMassUnitsToHt 34480864.        //!< conversion factor for atomic weight in units to mass in Ht (protonmass/electronmass * electron_mass_in_Ht
-#define ElectronMass_Ht 18778.865            //!< electron mass in Ht
-#define ElectronMass_eV 510998.903           //!< electron mass in eV
-#define Units2Electronmass (AtomicMassUnitsToeV/ElectronMass_eV) //!< atomic mass unit in eV/ electron mass in eV = 1 822.88863
-#define Atomictime2Femtoseconds 0.024188843     //!< Atomictime in fs
+enum { NDIM = 3 };   //!< number of spatial dimensions
+enum { MAX_ELEMENTS = 128}; //!< maximum number of elements for certain lookup tables
 
-#define VERSIONSTRING "v1.0"
+extern "C" const double MYEPSILON;  //!< machine epsilon precision
+extern "C" const double AtomicLengthToAngstroem; //!< conversion factor from atomic length/bohrradius to angstroem
+extern "C" const double AtomicEnergyToKelvin;  //!< conversion factor from atomic energy to kelvin via boltzmann factor
+extern "C" const double KelvinToAtomicTemperature;    //!< conversion factor for Kelvin to atomic temperature (Hartree over k_B)
+extern "C" const double KelvinToeV;                   //!< conversion factor for Kelvin to Ht (k_B * T = energy), thus Boltzmann constant in eV/K
+extern "C" const double AtomicMassUnitsToeV;        //!< conversion factor for atomic weight in units to mass in eV
+extern "C" const double AtomicMassUnitsToHt;        //!< conversion factor for atomic weight in units to mass in Ht (protonmass/electronmass * electron_mass_in_Ht
+extern "C" const double ElectronMass_Ht;            //!< electron mass in Ht
+extern "C" const double ElectronMass_eV;           //!< electron mass in eV
+extern "C" const double Units2Electronmass; //!< atomic mass unit in eV/ electron mass in eV = 1 822.88863
+extern "C" const double Atomictime2Femtoseconds;     //!< Atomictime in fs
 
-#define LocalPath "./"
+extern "C" const char* VERSIONSTRING;
+
+extern "C" const char* LocalPath;
 
 //enum BondOrderScheme { NoScheme, BottomUp, TopDown, ANOVA, Combined }; //!< Fragmentation scheme used in BOSS
@@ -48,39 +49,42 @@
 
 // maximum length of any char array
-#define MAXSTRINGSIZE 255
+enum { MAXSTRINGSIZE = 255 };
 
 // various standard filenames
-#define DEFAULTCONFIG "main_pcp_linux"    //!< default filename of config file
-#define CONVEXENVELOPE "ConvexEnvelope.dat"    //!< default filename of convex envelope tecplot data file
-#define KEYSETFILE "KeySets.dat"    //!< default filename of BOSSANOVA key sets file
-#define ADJACENCYFILE "Adjacency.dat"    //!< default filename of BOSSANOVA adjacancy file
-#define TEFACTORSFILE "TE-Factors.dat"    //!< default filename of BOSSANOVA total energy factors file
-#define FORCESFILE "Forces-Factors.dat"    //!< default filename of BOSSANOVA force factors file
-#define HCORRECTIONSUFFIX "Hcorrection.dat"    //!< default filename of BOSSANOVA H correction file (unwanted saturation interaction)
-#define FITCONSTANTSUFFIX "FitConstant.dat"   //!< suffix of default filename of BOSSANOVA fit constants file (unwanted saturation interaction)
-#define SHIELDINGSUFFIX "sigma_all.csv"                //!< default filename of BOSSANOVA shieldings file
-#define SHIELDINGPASSUFFIX "sigma_all_PAS.csv"                 //!< default filename of BOSSANOVA shieldings PAS file
-#define ORDERATSITEFILE "OrderAtSite.dat"    //!< default filename of BOSSANOVA Bond Order at each atom file
-#define ENERGYPERFRAGMENT "EnergyPerFragment"    //!< default filename of BOSSANOVA Energy contribution Per Fragment file
-#define FRAGMENTPREFIX "BondFragment"    //!< default filename prefix of BOSSANOVA fragment config and directories 
-#define STANDARDCONFIG "unknown.conf"    //!< default filename of standard config file
-#define STANDARDELEMENTSDB "elements.db"    //!< default filename of elements data base with masses, Z, VanDerWaals radii, ...
-#define STANDARDVALENCEDB "valence.db"    //!< default filename of valence number per element database
-#define STANDARDORBITALDB "orbitals.db"    //!< default filename of orbitals per element database
-#define STANDARDHBONDDISTANCEDB "Hbonddistance.db"    //!< default filename of typial bond distance to hydrogen database
-#define STANDARDHBONDANGLEDB "Hbondangle.db"    //!< default filename of typial bond angle to hydrogen database
+extern "C" const char *DEFAULTCONFIG;    //!< default filename of config file
+extern "C" const char *CONVEXENVELOPE;    //!< default filename of convex envelope tecplot data file
+extern "C" const char *KEYSETFILE;    //!< default filename of BOSSANOVA key sets file
+extern "C" const char *ADJACENCYFILE;    //!< default filename of BOSSANOVA adjacancy file
+extern "C" const char *TEFACTORSFILE;    //!< default filename of BOSSANOVA total energy factors file
+extern "C" const char *FORCESFILE;    //!< default filename of BOSSANOVA force factors file
+extern "C" const char *HCORRECTIONSUFFIX;    //!< default filename of BOSSANOVA H correction file (unwanted saturation interaction)
+extern "C" const char *FITCONSTANTSUFFIX;   //!< suffix of default filename of BOSSANOVA fit constants file (unwanted saturation interaction)
+extern "C" const char *SHIELDINGSUFFIX;                //!< default filename of BOSSANOVA shieldings file
+extern "C" const char *SHIELDINGPASSUFFIX;                 //!< default filename of BOSSANOVA shieldings PAS file
+extern "C" const char *ORDERATSITEFILE;    //!< default filename of BOSSANOVA Bond Order at each atom file
+extern "C" const char *ENERGYPERFRAGMENT;    //!< default filename of BOSSANOVA Energy contribution Per Fragment file
+extern "C" const char *FRAGMENTPREFIX;    //!< default filename prefix of BOSSANOVA fragment config and directories
+extern "C" const char *STANDARDCONFIG;    //!< default filename of standard config file
+extern "C" const char *STANDARDELEMENTSDB;    //!< default filename of elements data base with masses, Z, VanDerWaals radii, ...
+extern "C" const char *STANDARDVALENCEDB;    //!< default filename of valence number per element database
+extern "C" const char *STANDARDORBITALDB;    //!< default filename of orbitals per element database
+extern "C" const char *STANDARDHBONDDISTANCEDB;    //!< default filename of typial bond distance to hydrogen database
+extern "C" const char *STANDARDHBONDANGLEDB;    //!< default filename of typial bond angle to hydrogen database
 
 // some values
-#define SOLVENTDENSITY_A 0.6022142
-#define SOLVENTDENSITY_a0 0.089238936
+extern "C" const double SOLVENTDENSITY_A;
+extern "C" const double SOLVENTDENSITY_a0;
 
 
-#define UPDATECOUNT 10  //!< update ten sites per BOSSANOVA interval
+extern "C" const int UPDATECOUNT;  //!< update ten sites per BOSSANOVA interval
 
-#define STD_MENU_LENGTH 60
-#define STD_MENU_TITLE_SPACER '='
-#define STD_SEPERATOR_SPACER '-'
+extern "C" const int STD_MENU_LENGTH;
+extern "C" const char STD_MENU_TITLE_SPACER;
+extern "C" const char STD_SEPERATOR_SPACER;
 
-#define MOLECUILDER_NAME "Molecuilder"
+extern "C" const char *MOLECUILDER_NAME;
+
+const extern unsigned int MAX_POOL_FRAGMENTATION;
+const extern unsigned int MAX_FRAGMENTATION_SKIPS;
 
 #endif /*DEFS_HPP_*/
Index: src/element.cpp
===================================================================
--- src/element.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/element.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -4,4 +4,9 @@
  * 
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -23,8 +28,4 @@
   VanDerWaalsRadius(0),
 	Z(-1),
-	previous(NULL),
-	next(NULL),
-	sort(NULL),
-	No(-1),
 	Valence(0),
 	NoValenceOrbitals(0)
@@ -32,7 +33,39 @@
 };
 
+element::element(const element &src) :
+  mass(src.mass),
+  CovalentRadius(src.CovalentRadius),
+  VanDerWaalsRadius(src.VanDerWaalsRadius),
+  Z(src.Z),
+  Valence(src.Valence),
+  NoValenceOrbitals(src.NoValenceOrbitals),
+  name(src.name),
+  symbol(src.symbol)
+{
+  period = src.period;
+  group = src.group;
+  block = src.block;
+}
+
 /** Destructor of class element.
  */
 element::~element() {};
+
+element &element::operator=(const element &src){
+  if(this!=&src){
+    mass=src.mass;
+    CovalentRadius=src.CovalentRadius;
+    VanDerWaalsRadius=src.VanDerWaalsRadius;
+    Z=src.Z;
+    Valence=src.Valence;
+    NoValenceOrbitals=src.NoValenceOrbitals;
+    name=src.name;
+    symbol=src.symbol;
+    period = src.period;
+    group = src.group;
+    block = src.block;
+  }
+  return *this;
+}
 
 /** Prints element data to \a *out.
@@ -67,5 +100,22 @@
 }
 
-string element::getSymbol() const{
-  return string(symbol);
+string &element::getSymbol(){
+  return symbol;
 }
+
+const string &element::getSymbol() const{
+  return symbol;
+}
+
+std::string &element::getName(){
+  return name;
+}
+
+const std::string &element::getName() const{
+  return name;
+}
+
+std::ostream &operator<<(std::ostream &ost,const element &elem){
+  ost << elem.getName() << "(" << elem.getNumber() << ")";
+  return ost;
+}
Index: src/element.hpp
===================================================================
--- src/element.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/element.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -16,5 +16,5 @@
 #endif
 
-#include <iostream>
+#include <iosfwd>
 #include <string>
 
@@ -33,13 +33,7 @@
     double VanDerWaalsRadius;  //!< can-der-Waals radius
     int Z;          //!< atomic number
-    char name[64];  //!< atom name, i.e. "Hydrogren"
-    char symbol[3]; //!< short form of the atom, i.e. "H"
-    char period[8];    //!< period: n quantum number
-    char group[8];    //!< group: l quantum number
-    char block[8];    //!< block: l quantum number
-    element *previous;  //!< previous item in list
-    element *next;  //!< next element in list
-    int *sort;      //!< sorc criteria
-    int No;         //!< number of element set on periodentafel::Output()
+    std::string period;    //!< period: n quantum number
+    std::string group;    //!< group: l quantum number
+    std::string block;    //!< block: l quantum number
     double Valence;   //!< number of valence electrons for this element
     int NoValenceOrbitals;  //!< number of valence orbitals, used for determining bond degree in molecule::CreateConnectmatrix()
@@ -47,18 +41,27 @@
     double HBondAngle[NDIM];     //!< typical angle for one, two, three bonded hydrogen (in degrees)
 
-  element();
-  ~element();
+    element();
+    element(const element&);
+    ~element();
 
-  // accessor functions
-  atomicNumber_t getNumber() const;
-  std::string getSymbol() const;
+    element &operator=(const element&);
 
-  //> print element entries to screen
-  bool Output(std::ostream * const out) const;
-  bool Checkout(std::ostream * const out, const int No, const int NoOfAtoms) const;
+    // accessor functions
+    atomicNumber_t getNumber() const;
+    std::string &getSymbol();
+    const std::string &getSymbol() const;
+    std::string &getName();
+    const std::string &getName() const;
+
+    //> print element entries to screen
+    bool Output(std::ostream * const out) const;
+    bool Checkout(std::ostream * const out, const int No, const int NoOfAtoms) const;
 
   private:
+    std::string name;  //!< atom name, i.e. "Hydrogren"
+    std::string symbol; //!< short form of the atom, i.e. "H"
 };
 
+std::ostream &operator<<(std::ostream&,const element&);
 
 #endif /* ELEMENT_HPP_ */
Index: src/elements_db.cpp
===================================================================
--- src/elements_db.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/elements_db.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/ellipsoid.cpp
===================================================================
--- src/ellipsoid.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/ellipsoid.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -15,11 +20,13 @@
 #include <set>
 
+#include "BoundaryPointSet.hpp"
 #include "boundary.hpp"
 #include "ellipsoid.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "tesselation.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Determines squared distance for a given point \a x to surface of ellipsoid.
@@ -34,5 +41,5 @@
   Vector helper, RefPoint;
   double distance = -1.;
-  double Matrix[NDIM*NDIM];
+  Matrix Matrix;
   double InverseLength[3];
   double psi,theta,phi; // euler angles in ZX'Z'' convention
@@ -51,14 +58,14 @@
   theta = EllipsoidAngle[1];
   phi = EllipsoidAngle[2];
-  Matrix[0] = cos(psi)*cos(phi) - sin(psi)*cos(theta)*sin(phi);
-  Matrix[1] = -cos(psi)*sin(phi) - sin(psi)*cos(theta)*cos(phi);
-  Matrix[2] = sin(psi)*sin(theta);
-  Matrix[3] = sin(psi)*cos(phi) + cos(psi)*cos(theta)*sin(phi);
-  Matrix[4] = cos(psi)*cos(theta)*cos(phi) - sin(psi)*sin(phi);
-  Matrix[5] = -cos(psi)*sin(theta);
-  Matrix[6] = sin(theta)*sin(phi);
-  Matrix[7] = sin(theta)*cos(phi);
-  Matrix[8] = cos(theta);
-  helper.MatrixMultiplication(Matrix);
+  Matrix.set(0,0, cos(psi)*cos(phi) - sin(psi)*cos(theta)*sin(phi));
+  Matrix.set(1,0, -cos(psi)*sin(phi) - sin(psi)*cos(theta)*cos(phi));
+  Matrix.set(2,0, sin(psi)*sin(theta));
+  Matrix.set(0,1, sin(psi)*cos(phi) + cos(psi)*cos(theta)*sin(phi));
+  Matrix.set(1,1, cos(psi)*cos(theta)*cos(phi) - sin(psi)*sin(phi));
+  Matrix.set(2,1, -cos(psi)*sin(theta));
+  Matrix.set(0,2, sin(theta)*sin(phi));
+  Matrix.set(1,2, sin(theta)*cos(phi));
+  Matrix.set(2,2, cos(theta));
+  helper *= Matrix;
   helper.ScaleAll(InverseLength);
   //Log() << Verbose(4) << "Transformed RefPoint is at " << helper << "." << endl;
@@ -73,14 +80,14 @@
   phi = -EllipsoidAngle[2];
   helper.ScaleAll(EllipsoidLength);
-  Matrix[0] = cos(psi)*cos(phi) - sin(psi)*cos(theta)*sin(phi);
-  Matrix[1] = -cos(psi)*sin(phi) - sin(psi)*cos(theta)*cos(phi);
-  Matrix[2] = sin(psi)*sin(theta);
-  Matrix[3] = sin(psi)*cos(phi) + cos(psi)*cos(theta)*sin(phi);
-  Matrix[4] = cos(psi)*cos(theta)*cos(phi) - sin(psi)*sin(phi);
-  Matrix[5] = -cos(psi)*sin(theta);
-  Matrix[6] = sin(theta)*sin(phi);
-  Matrix[7] = sin(theta)*cos(phi);
-  Matrix[8] = cos(theta);
-  helper.MatrixMultiplication(Matrix);
+  Matrix.set(0,0, cos(psi)*cos(phi) - sin(psi)*cos(theta)*sin(phi));
+  Matrix.set(1,0, -cos(psi)*sin(phi) - sin(psi)*cos(theta)*cos(phi));
+  Matrix.set(2,0, sin(psi)*sin(theta));
+  Matrix.set(0,1, sin(psi)*cos(phi) + cos(psi)*cos(theta)*sin(phi));
+  Matrix.set(1,1, cos(psi)*cos(theta)*cos(phi) - sin(psi)*sin(phi));
+  Matrix.set(2,1, -cos(psi)*sin(theta));
+  Matrix.set(0,2, sin(theta)*sin(phi));
+  Matrix.set(1,2, sin(theta)*cos(phi));
+  Matrix.set(2,2, cos(theta));
+  helper *= Matrix;
   //Log() << Verbose(4) << "Intersection is at " << helper << "." << endl;
 
@@ -303,6 +310,6 @@
               if ((current != PickedAtomNrs.end()) && (*current == index)) {
                 Candidate = (*Runner);
-                DoLog(2) && (Log() << Verbose(2) << "Current picked node is " << **Runner << " with index " << index << "." << endl);
-                x[PointsPicked++] = *Candidate->node;    // we have one more atom picked
+                DoLog(2) && (Log() << Verbose(2) << "Current picked node is " << (*Runner)->getName() << " with index " << index << "." << endl);
+                x[PointsPicked++] = Candidate->getPosition();    // we have one more atom picked
                 current++;    // next pre-picked atom
               }
@@ -350,5 +357,5 @@
       //Log() << Verbose(3) << "Current node is " << *Runner->second->node << " with " << value << " ... " << threshold << ": ";
       if (value > threshold) {
-        x[PointsPicked] = (*Runner->second->node->node);
+        x[PointsPicked] = (Runner->second->node->getPosition());
         PointsPicked++;
         //Log() << Verbose(0) << "IN." << endl;
@@ -387,5 +394,5 @@
   Center.Zero();
   for (PointMap::iterator Runner = T->PointsOnBoundary.begin(); Runner != T->PointsOnBoundary.end(); Runner++)
-    Center += (*Runner->second->node->node);
+    Center += (Runner->second->node->getPosition());
   Center.Scale(1./T->PointsOnBoundaryCount);
   DoLog(1) && (Log() << Verbose(1) << "Center is at " << Center << "." << endl);
Index: src/graph.cpp
===================================================================
--- src/graph.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/graph.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -4,4 +4,9 @@
  *
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -13,5 +18,6 @@
 #include "config.hpp"
 #include "graph.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 
Index: src/graph.hpp
===================================================================
--- src/graph.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/graph.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -27,5 +27,4 @@
 class molecule;
 
-class Graph;
 class SubGraph;
 class Node;
@@ -34,22 +33,24 @@
 /********************************************** definitions *********************************/
 
-#define NodeMap pair < int, class Node* >
-#define EdgeMap multimap < class Node*, class Edge* >
+typedef std::pair < int, class Node* > NodeMap;
+typedef std::multimap < class Node*, class Edge* > EdgeMap;
 
-#define KeyStack deque<int>
-#define KeySet set<int>
-#define NumberValuePair pair<int, double>
-#define Graph map <KeySet, NumberValuePair, KeyCompare >
-#define GraphPair pair <KeySet, NumberValuePair >
-#define KeySetTestPair pair<KeySet::iterator, bool>
-#define GraphTestPair pair<Graph::iterator, bool>
+typedef std::deque<int> KeyStack;
+typedef std::set<int> KeySet;
+typedef std::pair<int, double> NumberValuePair;
 
-
-/******************************** Some small functions and/or structures **********************************/
-
+// needed for definition of Graph and GraphTestPair
 struct KeyCompare
 {
   bool operator() (const KeySet SubgraphA, const KeySet SubgraphB) const;
 };
+
+typedef std::map <KeySet, NumberValuePair, KeyCompare > Graph;
+typedef std::pair <KeySet, NumberValuePair > GraphPair;
+typedef std::pair<KeySet::iterator, bool> KeySetTestPair;
+typedef std::pair<Graph::iterator, bool> GraphTestPair;
+
+
+/******************************** Some small functions and/or structures **********************************/
 
 //bool operator < (KeySet SubgraphA, KeySet SubgraphB);   //note: this declaration is important, otherwise normal < is used (producing wrong order)
Index: src/joiner.cpp
===================================================================
--- src/joiner.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/joiner.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -8,4 +8,9 @@
 //============================ INCLUDES ===========================
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -13,8 +18,8 @@
 
 #include "datacreator.hpp"
-#include "helpers.hpp"
-#include "memoryallocator.hpp"
+#include "Helpers/helpers.hpp"
 #include "parser.hpp"
 #include "periodentafel.hpp"
+#include "Helpers/Verbose.hpp"
 
 //============================== MAIN =============================
@@ -209,5 +214,9 @@
   prefix << dir << ForceFragmentSuffix;
   if (!ForceFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
-  if (!CreateDataFragment(EnergyFragments, KeySet, argv[1], FRAGMENTPREFIX ENERGYPERFRAGMENT, "fragment energy versus the Fragment No", "today", CreateEnergy)) return 1;
+  {
+    std::string fileprefix(FRAGMENTPREFIX);
+    fileprefix += ENERGYPERFRAGMENT;
+    if (!CreateDataFragment(EnergyFragments, KeySet, argv[1], fileprefix.c_str(), "fragment energy versus the Fragment No", "today", CreateEnergy)) return 1;
+  }
   if (!NoHessian) {
     prefix.str(" ");
Index: src/leastsquaremin.cpp
===================================================================
--- src/leastsquaremin.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/leastsquaremin.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -11,5 +16,5 @@
 
 #include "leastsquaremin.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 /** Determines sum of squared distances of \a X to all \a **vectors.
Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/linkedcell.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,13 +5,19 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "atom.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "tesselation.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 // ========================================================= class LinkedCell ===========================================
@@ -20,11 +26,11 @@
 /** Constructor for class LinkedCell.
  */
-LinkedCell::LinkedCell()
-{
-  LC = NULL;
+LinkedCell::LinkedCell() :
+  LC(NULL),
+  RADIUS(0.),
+  index(-1)
+{
   for(int i=0;i<NDIM;i++)
     N[i] = 0;
-  index = -1;
-  RADIUS = 0.;
   max.Zero();
   min.Zero();
@@ -35,13 +41,13 @@
  * \param RADIUS edge length of cells
  */
-LinkedCell::LinkedCell(const PointCloud * const set, const double radius)
+LinkedCell::LinkedCell(const PointCloud * const set, const double radius) :
+  LC(NULL),
+  RADIUS(radius),
+  index(-1)
 {
   TesselPoint *Walker = NULL;
 
-  RADIUS = radius;
-  LC = NULL;
   for(int i=0;i<NDIM;i++)
     N[i] = 0;
-  index = -1;
   max.Zero();
   min.Zero();
@@ -55,6 +61,6 @@
   Walker = set->GetPoint();
   for (int i=0;i<NDIM;i++) {
-    max[i] = Walker->node->at(i);
-    min[i] = Walker->node->at(i);
+    max[i] = Walker->at(i);
+    min[i] = Walker->at(i);
   }
   set->GoToFirst();
@@ -62,8 +68,8 @@
     Walker = set->GetPoint();
     for (int i=0;i<NDIM;i++) {
-      if (max[i] < Walker->node->at(i))
-        max[i] = Walker->node->at(i);
-      if (min[i] > Walker->node->at(i))
-        min[i] = Walker->node->at(i);
+      if (max[i] < Walker->at(i))
+        max[i] = Walker->at(i);
+      if (min[i] > Walker->at(i))
+        min[i] = Walker->at(i);
     }
     set->GoToNext();
@@ -95,5 +101,5 @@
     Walker = set->GetPoint();
     for (int i=0;i<NDIM;i++) {
-      n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
+      n[i] = static_cast<int>(floor((Walker->at(i) - min[i])/RADIUS));
     }
     index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -111,12 +117,12 @@
  * \param RADIUS edge length of cells
  */
-LinkedCell::LinkedCell(LinkedNodes *set, const double radius)
+LinkedCell::LinkedCell(LinkedNodes *set, const double radius) :
+  LC(NULL),
+  RADIUS(radius),
+  index(-1)
 {
   class TesselPoint *Walker = NULL;
-  RADIUS = radius;
-  LC = NULL;
   for(int i=0;i<NDIM;i++)
     N[i] = 0;
-  index = -1;
   max.Zero();
   min.Zero();
@@ -129,14 +135,14 @@
   LinkedNodes::iterator Runner = set->begin();
   for (int i=0;i<NDIM;i++) {
-    max[i] = (*Runner)->node->at(i);
-    min[i] = (*Runner)->node->at(i);
+    max[i] = (*Runner)->at(i);
+    min[i] = (*Runner)->at(i);
   }
   for (LinkedNodes::iterator Runner = set->begin(); Runner != set->end(); Runner++) {
     Walker = *Runner;
     for (int i=0;i<NDIM;i++) {
-      if (max[i] < Walker->node->at(i))
-        max[i] = Walker->node->at(i);
-      if (min[i] > Walker->node->at(i))
-        min[i] = Walker->node->at(i);
+      if (max[i] < Walker->at(i))
+        max[i] = Walker->at(i);
+      if (min[i] > Walker->at(i))
+        min[i] = Walker->at(i);
     }
   }
@@ -166,5 +172,5 @@
     Walker = *Runner;
     for (int i=0;i<NDIM;i++) {
-      n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
+      n[i] = static_cast<int>(floor((Walker->at(i) - min[i])/RADIUS));
     }
     index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -247,8 +253,8 @@
  * \return Vector is inside bounding box - true, else - false
  */
-bool LinkedCell::SetIndexToVector(const Vector * const x) const
+bool LinkedCell::SetIndexToVector(const Vector & x) const
 {
   for (int i=0;i<NDIM;i++)
-    n[i] = (int)floor((x->at(i) - min[i])/RADIUS);
+    n[i] = (int)floor((x.at(i) - min[i])/RADIUS);
 
   return CheckBounds();
@@ -263,5 +269,5 @@
   bool status = false;
   for (int i=0;i<NDIM;i++) {
-    n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
+    n[i] = static_cast<int>(floor((Walker->at(i) - min[i])/RADIUS));
   }
   index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -403,5 +409,5 @@
       Walker = *Runner;
       //Log() << Verbose(1) << "Current neighbour is at " << *Walker->node << "." << endl;
-      if ((center->DistanceSquared(*Walker->node) - radiusSquared) < MYEPSILON) {
+      if ((Walker->DistanceSquared(*center) - radiusSquared) < MYEPSILON) {
         TesselList->push_back(Walker);
       }
Index: src/linkedcell.hpp
===================================================================
--- src/linkedcell.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/linkedcell.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -24,5 +24,5 @@
 
 #include "defs.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 /****************************************** forward declarations *****************************/
@@ -60,5 +60,5 @@
     const LinkedCell::LinkedNodes* GetRelativeToCurrentCell(const int relative[NDIM])const ;
     bool SetIndexToNode(const TesselPoint * const Walker)const ;
-    bool SetIndexToVector(const Vector * const x)const ;
+    bool SetIndexToVector(const Vector &x)const ;
     double SetClosestIndexToOutsideVector(const Vector * const x) const;
     bool CheckBounds()const ;
